/***
*  fastdd.c
* 
*  replace "dd if=argv[1] skip=argv[2]"
*  use "lseek" for skip to speed up
* 
*  for mulinux busybox
*
*  Alain Spineux 9/98
***/

#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <stdlib.h>
#include <unistd.h>

#include "internal.h"

#define BUFSIZE 1024 

const char fastdd_usage[]="fastdd file [offset]: \n\
\tread file, starting form offset, in Kb\n";

int fastdd_main(struct FileInfo *i,int argc, char *argv[])

{
  char buf[BUFSIZE];
  int fd=0;
  int offset=0;
  int n;

  fd=open(argv[1], O_RDONLY);

  if ( argc > 2 ) offset=atoi(argv[2]);

  lseek(fd, 1024*(offset), SEEK_SET); 

  while ( 1 ) {
        n=read(fd, buf, BUFSIZE);
        if (n == 0) break;          /* EOF.  */
        if (n < 0) return -2;
        write(1, buf, n);
  }
  close(fd); 
  return 0;
}

