#include "internal.h"
#include <stdio.h>
#include <string.h>
#include <errno.h>

static const struct Applet	applets[] = {

{ "chmod",	chmod_main,		0,			chmod_usage,	2,	-1	},
{ "chown",	chown_main,		0,			chown_usage,	2,	-1	},
{ "clear",	clear_main,		0,			clear_usage,	0,	 0	},
{ "date",	date_main,		0,			date_usage,		0,	 0	},
{ "df",		df_main,		0,			df_usage,		0,	-1	},
{ "dmesg",	dmesg_main,		0,			dmesg_usage,		0,	 0	},
{ "fdflush",monadic_main,	fdflush_fn,	fdflush_usage,	1,	-1	},

/* my functions: M.A. */

{ "rgrep",	rgrep_main,		0,			rgrep_usage,		1,	-1	},
{ "tee",	tee_main,		0,			tee_usage,		1,	-1	},
{ "expr",	expr_main,		0,			expr_usage,		1,	-1	},
{ "which",	which_main,		0,			which_usage,		1,	-1	},
{ "fastdd",	fastdd_main,		0,			fastdd_usage,		1,	-1	},

/* end */

{ "kill",	kill_main,		0,			kill_usage,		1,	-1	},
{ "kill",	kill_main,		0,			kill_usage,		1,	-1	},
{ "ln",		dyadic_main,	ln_fn,		ln_usage,		2,	-1	},
{ "mkdir",	monadic_main,	mkdir_fn,	mkdir_usage,	1,	-1	},
{ "mkswap",	mkswap_main,	0,			mkswap_usage,	1,	-1	},
{ "pwd",	pwd_main,		0,			pwd_usage,		0,	 0	},
{ "rm",		rm_main,		rm_fn,		rm_usage,		1,	-1	},
{ "rmdir",	monadic_main,	rmdir_fn,	rmdir_usage,	1,	-1	},
{ "sleep",	sleep_main,		0,			sleep_usage,	1,	-1	},
{ "swapoff",monadic_main,	swapoff_fn,	swapoff_usage,	1,	-1	},
{ "swapon",	monadic_main,	swapon_fn,	swapon_usage,	1,	-1	},
{ "sync",	sync_main,		0,			sync_usage,		0,	 0	},
{ "touch",	monadic_main,	touch_fn,	touch_usage,	1,	-1	},
{ "update",	update_main,	0,			update_usage,	0,	-1	},
{ 0 }
};

extern int
main(int argc, char * * argv)
{
	char *			s = argv[0];
	char *			name = argv[0];
	const struct Applet *	a = applets;
	struct FileInfo	i;
	

	while ( *s != '\0' ) {
		if ( *s++ == '/' )
			name = s;
	}

#ifdef INCLUDE_DINSTALL
	if ( strcmp(name,"dinstall") == 0) {
		int status;

		status = dinstall_main();
		exit (status);
	}
#endif

	while ( a->name != 0 ) {
		if ( strcmp(name, a->name) == 0 ) {
			int	status;

			if ( argc - 1 < a->minimumArgumentCount
			 || (a->maximumArgumentCount > 0
			  && argc - 1 > a->maximumArgumentCount )
			 || (a->usage && argc >= 2 && strcmp(argv[1], "--help") == 0 ) ) {
				usage(a->usage);
				return 1;
			}
			errno = 0;
			memset((void *)&i, 0, sizeof(struct FileInfo));
			i.orWithMode = 0777;
			i.andWithMode = ~0;
			i.applet = a;
			status = ((*(a->main))(&i, argc, argv));
			if ( status < 0 ) {
				fprintf(
				 stderr
				,"%s: %s\n"
				,a->name
				,strerror(errno));
			}
			exit(status);
		}
		a++;
	}
	fprintf(stderr, "error: called as %s\n", argv[0]);
	return -1;
}
